
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Trust_adjustmentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const trust_adjustments = await db.trust_adjustments.create(
            {
                id: data.id || undefined,
        
        delta: data.delta
        ||
        null
            ,
            
        reason: data.reason
        ||
        null
            ,
            
        created_at_ts: data.created_at_ts
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await trust_adjustments.setBusiness( data.business || null, {
            transaction,
        });
        
        await trust_adjustments.setAdmin_user( data.admin_user || null, {
            transaction,
        });
        

        

        

        return trust_adjustments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const trust_adjustmentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                delta: item.delta
            ||
            null
            ,
            
                reason: item.reason
            ||
            null
            ,
            
                created_at_ts: item.created_at_ts
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const trust_adjustments = await db.trust_adjustments.bulkCreate(trust_adjustmentsData, { transaction });

        // For each item created, replace relation files
        

        return trust_adjustments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const trust_adjustments = await db.trust_adjustments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.delta !== undefined) updatePayload.delta = data.delta;
        
        
        if (data.reason !== undefined) updatePayload.reason = data.reason;
        
        
        if (data.created_at_ts !== undefined) updatePayload.created_at_ts = data.created_at_ts;
        
        
        updatePayload.updatedById = currentUser.id;

        await trust_adjustments.update(updatePayload, {transaction});

        
        
        if (data.business !== undefined) {
            await trust_adjustments.setBusiness(
              
              data.business,
              
              { transaction }
            );
        }
        
        if (data.admin_user !== undefined) {
            await trust_adjustments.setAdmin_user(
              
              data.admin_user,
              
              { transaction }
            );
        }
        

        
        

        

        return trust_adjustments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const trust_adjustments = await db.trust_adjustments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of trust_adjustments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of trust_adjustments) {
                await record.destroy({transaction});
            }
        });


        return trust_adjustments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const trust_adjustments = await db.trust_adjustments.findByPk(id, options);

        await trust_adjustments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await trust_adjustments.destroy({
            transaction
        });

        return trust_adjustments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const trust_adjustments = await db.trust_adjustments.findOne(
            { where },
            { transaction },
        );

        if (!trust_adjustments) {
            return trust_adjustments;
        }

        const output = trust_adjustments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.business = await trust_adjustments.getBusiness({
            transaction
        });
        
        
        output.admin_user = await trust_adjustments.getAdmin_user({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.businesses,
        as: 'business',
        
        where: filter.business ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.business.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'admin_user',
        
        where: filter.admin_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.admin_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.admin_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.reason) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'trust_adjustments',
                        'reason',
                        filter.reason,
                    ),
                };
            }
            

            
            

            
            if (filter.deltaRange) {
                const [start, end] = filter.deltaRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    delta: {
                    ...where.delta,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    delta: {
                    ...where.delta,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.created_at_tsRange) {
                const [start, end] = filter.created_at_tsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.trust_adjustments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'trust_adjustments',
                        'reason',
                        query,
                    ),
                ],
            };
        }

        const records = await db.trust_adjustments.findAll({
            attributes: [ 'id', 'reason' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reason', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reason,
        }));
    }

    
};

